#!/bin/bash

set -e
############################################
#                Starting.                 #
############################################


echo "Preparing build environment!"

FILE="$HOME/build_k8vavoom"
if [ -d "$FILE" ]; then
    echo "Build directory is avaible!"
else
    echo "Build directory is not avaible! Making..." ;
        mkdir "$HOME/build_k8vavoom" ;
        cd "$HOME/build_k8vavoom"
    echo "Directory maked and mounted!";
fi

clear;
echo "Hello! This a build/update script for k8vavoom!";
echo "When you building a k8vavoom, you supporting communism! ;)";
echo "Script writed by TerminalHash with little help from friends.";
echo "							version vShell_2.0";
PS3='Please enter your choice (Press Enter, if you don`t see menu): '
options=("Check dependencies" "Grab/Update sources" "Install k8vavoom" "Update k8vavoom" "Exit")
select opt in "${options[@]}"
do
    case $opt in

# ======= Dependencies ======= #

"Check dependencies") echo "Checking dependencies for k8vavoom!";

if pkg-config --exists opengl; then
    echo "OpenGL is present.";
else
    echo "opengl not installed!";
    MYLIST="$MYLIST opengl"
fi

#########
# SDL2. #
#########

if pkg-config --exists sdl2; then
    echo "SDL2 is present.";
else
    echo "sdl2 not installed!";
    MYLIST="$MYLIST sdl2"
fi

###########
# OpenAl. #
###########

if pkg-config --exists openal; then
    echo "OpenAl is present.";
else
    echo "openal not installed!";
    MYLIST="$MYLIST openal"
fi
########
# Git. #
########

if command -v git; then
    echo "Git is present."
else
    echo "Git not installed!";
    MYLIST="$MYLIST git"
fi

##########
# Cmake. #
##########

if command -v cmake; then
    echo "Cmake is present."
else
    echo "Cmake not installed!";
    MYLIST="$MYLIST cmake"
fi

###############
# PKG-Config. #
###############

if command -v pkg-config; then
    echo "PKG-Config is present."
else
    echo "PKG-Config not installed!";
    MYLIST="$MYLIST pkg-config"
fi

#########
# Sudo. #
#########

if command -v sudo; then
    echo "Sudo is present."
else
    echo "Sudo not installed!";
    MYLIST="$MYLIST sudo"
fi

if [ -n "$MYLIST" ]; then
    echo "Please, install this packages: $MYLIST";
    exit 1;
fi

echo "All dependencies installed! Good, we are working on.";;

# ======= Sources ======= #

"Grab/Update sources" ) echo "Checking sources!";

FILE="$HOME/build_k8vavoom/k8vavoom"
if [ -d "$FILE" ]; then
    echo "k8vavoom sources is avaible! Updating..." ;
        cd "$HOME/build_k8vavoom/k8vavoom" ;
            git pull ;
    echo "Sources is updated.";
else
    echo "k8vavoom sources is not avaible! Downloading...";
        cd "$HOME/build_k8vavoom" ;
        git clone https://repo.or.cz/k8vavoom.git ;
    echo "Done."
fi;;

# ======= Installing ======= #

"Install k8vavoom")    echo "Preparing build catalog!";
        cd "$HOME/build_k8vavoom" ;
        mkdir build ;
        cd build ;
    echo "Done.";

    echo "Configuration and building!"
        cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DENABLE_SERVER=ON -DCMAKE_INSTALL_PREFIX=/usr -DENABLE_VCCRUN=OFF -DARCH_LINUX_SPECIAL=$ARCH_LINUX_SPECIAL "$HOME/build_k8vavoom/k8vavoom" ;
        make -j$(nproc) ;
    echo "Done.";

    echo "Installing!";
        sudo make install ;
    echo "k8vavoom installed.";

    echo "Have a nice game! :)";
    echo "You'd better create '~/.k8vavoom/iwads' directory and put at least one";
    echo "IWAD file there to play a game. You can specify a game name with the";
    echo "corresponding command line switch, e.g. -doom, -doom2, -tnt, etc.";
        exit 0;;

# ======= Updating ======= #

"Update k8vavoom")    echo "Preparing build catalog!" ;
        cd "$HOME/build_k8vavoom" ;
        rm -R build ;
        mkdir build ;
        cd build ;
    echo "Done.";

    echo "Configuration and building!";
        cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DENABLE_SERVER=ON -DCMAKE_INSTALL_PREFIX=/usr -DENABLE_VCCRUN=OFF -DARCH_LINUX_SPECIAL=$ARCH_LINUX_SPECIAL "$HOME/build_k8vavoom/k8vavoom" ;
        make -j$(nproc);
    echo "Done.";

    echo "Installing update!";
        sudo make install;
    echo "k8vavoom updated.";

    echo "Have a nice game! :)";
    exit 0;;

# ======= Exit ======= #

  "Exit") echo "Goodbye!"
    break;;
  * ) echo "Wutta?!" ;;
  esac
done
